﻿(function () {
    window.mmtpoci = window.mmtpoci || {
        _id: 1,
        _handlers: {},
        _postMessage: function (handle, name, data) {
            window.webkit.messageHandlers.mmtpoci.postMessage({ handle: handle, name: name, data: data });
        },
        _sendMessageAsync: function (name, data) {
            return new Promise((resolve, reject) => {
                const handle = 'm' + this._id++;
                this._handlers[handle] = { resolve, reject };
                this._postMessage(handle, name, data);
            });
        },
        _recvMessageAsync: function (handle, error, data) {
            if (handle == null)
                return;
            if (error)
                this._handlers[handle].reject(data);
            else
                this._handlers[handle].resolve(data);
            delete this._handlers[handle];
        },
        _sendMessage: function (name, data) {
            let res = prompt('mmtpoci:' + name + ':' + JSON.stringify(data));
            let reso = JSON.parse(res);
            if (reso.error)
                throw reso.data;
            return reso.data;
        },
        version: 2,
        hasSync: true,
        getItemAsync: function (key) { return this._sendMessageAsync('getItem', key); },
        setItemAsync: function (key, val) { return this._sendMessageAsync('setItem', { key: key, val: val }); },
        removeItemAsync: function (key) { return this._sendMessageAsync('removeItem', key); },
        getLoadingAsync: function () { return this._sendMessageAsync('getLoading'); },
        setLoadingAsync: function (loading) { return this._sendMessageAsync('setLoading', loading); },
        getItem: function (key) { return this._sendMessage('getItem', key); },
        setItem: function (key, val) { return this._sendMessage('setItem', { key: key, val: val }); },
        removeItem: function (key) { return this._sendMessage('removeItem', key); },
        getLoading: function () { return this._sendMessage('getLoading'); },
        setLoading: function (loading) { return this._sendMessage('setLoading', loading); }
    };
})();